- [HTTP request](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/get#body.HTTP_TEMPLATE)
- [Path parameters](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/get#body.PATH_PARAMETERS)
- [Query parameters](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/get#body.QUERY_PARAMETERS)
- [Request body](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/get#body.request_body)
- [Response body](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/get#body.response_body)
- [Authorization scopes](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/get#body.aspect)
- [Try it!](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/get#try-it)

Returns a range of values from a spreadsheet. The caller must specify the spreadsheet ID and a range.

### HTTP request

`GET https://sheets.googleapis.com/v4/spreadsheets/{spreadsheetId}/values/{range}`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `spreadsheetId` | `string` The ID of the spreadsheet to retrieve data from. |
| `range` | `string` The [A1 notation or R1C1 notation](https://developers.google.com/workspace/sheets/api/guides/concepts#cell) of the range to retrieve values from. |

### Query parameters

| Parameters ||
|---|---|
| `majorDimension` | ``enum (`https://developers.google.com/workspace/sheets/api/reference/rest/v4/Dimension`)`` The major dimension that results should use. For example, if the spreadsheet data in Sheet1 is: `A1=1,B1=2,A2=3,B2=4`, then requesting `range=Sheet1!A1:B2?majorDimension=ROWS` returns `[[1,2],[3,4]]`, whereas requesting `range=Sheet1!A1:B2?majorDimension=COLUMNS` returns `[[1,3],[2,4]]`. |
| `valueRenderOption` | ``enum (`https://developers.google.com/workspace/sheets/api/reference/rest/v4/ValueRenderOption`)`` How values should be represented in the output. The default render option is `https://developers.google.com/workspace/sheets/api/reference/rest/v4/ValueRenderOption`. |
| `dateTimeRenderOption` | ``enum (`https://developers.google.com/workspace/sheets/api/reference/rest/v4/DateTimeRenderOption`)`` How dates, times, and durations should be represented in the output. This is ignored if `https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/get#body.QUERY_PARAMETERS.value_render_option` is `https://developers.google.com/workspace/sheets/api/reference/rest/v4/ValueRenderOption`. The default dateTime render option is `https://developers.google.com/workspace/sheets/api/reference/rest/v4/DateTimeRenderOption`. |

### Request body

The request body must be empty.

### Response body

If successful, the response body contains an instance of `https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values#ValueRange`.

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/drive`
- `https://www.googleapis.com/auth/drive.readonly`
- `https://www.googleapis.com/auth/drive.file`
- `https://www.googleapis.com/auth/spreadsheets`
- `https://www.googleapis.com/auth/spreadsheets.readonly`

For more information, see the [Authorization guide](https://developers.google.com/workspace/guides/configure-oauth-consent).